Version 1.0 Class
Attribute VB_Name = "Track"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Track class -- TRACK.CLS
'   Represents a single song on a CD Title.
'
'   Properties:
'       Name
'       StartPosition
'       Length
'       Parent
'

' Name property
' (Read/write)
Public Name As String

' StartPosition property
' (Read/write)
Public StartPosition As Long

' Private parent variable.
Private mParent As Object

' Length property
' (Read/write)
Public Length  As Long

Public Property Get Application() As Object
    Set Application = Application
End Property

Public Function Parent(Optional objSetting, Optional iFlag)
    If IsMissing(objSetting) And IsMissing(iFlag) Then
        Set Parent = mParent
    ElseIf Not IsMissing(objSetting) And Not IsMissing(iFlag) Then
        If iFlag = FLAG_INTERNAL Then
            Set mParent = objSetting
        Else
            Err.Raise 5, Application.Name, "Invalid flag -- can't set Parent outside of application."
        End If
    Else
        Err.Raise 5, Application.Name, "Can't set Parent outside of application."
    End If
End Function

